package test;


import javax.swing.*;

import com.goldencode.p2j.ui.ColorRgb;
import com.goldencode.p2j.ui.client.SysColor;
import com.goldencode.p2j.ui.client.gui.driver.LineStroke;

import java.awt.*;
import java.util.ArrayList;

public class GraphicsOpsExamples2
{
   static class StrokeManager
   {
      // initialize dot pattern 
      private final Stroke dotStroke = new BasicStroke(LineStroke.DOT_LINE_WIDTH,
               BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL, 0.0f, new float[] {
                        LineStroke.DOT_STEP, LineStroke.DOT_STEP }, LineStroke.DOT_STEP);

      private final Stroke dotSmallStroke = new BasicStroke(LineStroke.DOT_LINE_WIDTH,
               BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL, 0.0f, new float[] {
                        LineStroke.DOT_STEP_SMALL, LineStroke.DOT_STEP_SMALL },
               LineStroke.DOT_STEP_SMALL);

      private final Stroke dotSmallThinStroke = new BasicStroke(LineStroke.DOT_LINE_THIN_WIDTH,
               BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL, 0.0f, new float[] {
                        LineStroke.DOT_STEP_SMALL, LineStroke.DOT_STEP_SMALL },
               LineStroke.DOT_STEP_SMALL);

      public final void setLineStroke(Graphics2D g2, LineStroke stroke, int strokeWidth)
      { // default line stroke
         Stroke javaStroke;

         switch (stroke)
         {
            case SPECIFIED_WIDTH:
               javaStroke = new BasicStroke(strokeWidth);
               break;
            case DOTTED:
               javaStroke = dotStroke;
               break;
            case DOTTED_SMALL:
               javaStroke = dotSmallStroke;
               break;
            case DOTTED_SMALL_THIN:
               javaStroke = dotSmallThinStroke;
               break;
            default:
               javaStroke = new BasicStroke();
         }

         g2.setStroke(javaStroke);
      }
   }

   public static void main(String[] args)
   {
      SwingUtilities.invokeLater(new Runnable()
      {
         public void run()
         {
            JFrame frame = new JFrame("Graphics Operations");
            frame.setSize(800, 600);
            frame.setLocation(150, 150);
            frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
            final StrokeManager strokeManager = new StrokeManager();
            frame.setContentPane(new JComponent()
            {
               public void paint(Graphics g)
               {
                  Graphics2D g2 = (Graphics2D) g;
                  strokeManager.setLineStroke(g2, LineStroke.SPECIFIED_WIDTH, 1);
                  g2.drawLine(10, 10, 790, 30);
                  g2.drawRect(40, 40, 55, 30);
                  //g2.fillRect(125, 40, 55, 30);
                  g2.drawLine(210, 40, 210, 70);
                  g2.drawLine(241, 40, 241, 70);
                  g2.drawLine(250, 40, 305, 40);
                  g2.drawLine(250, 70, 305, 70);
                  strokeManager.setLineStroke(g2, LineStroke.SPECIFIED_WIDTH, 2);
                  g2.drawLine(10, 80, 790, 100);
                  g2.drawRect(40, 110, 55, 30);
                  //g2.fillRect(125, 110, 55, 30);
                  g2.drawLine(210, 110, 210, 140);
                  g2.drawLine(241, 110, 241, 140);
                  g2.drawLine(250, 110, 305, 110);
                  g2.drawLine(250, 140, 305, 140);
                  strokeManager.setLineStroke(g2, LineStroke.SPECIFIED_WIDTH, 3);
                  g2.drawLine(10, 150, 790, 170);
                  g2.drawRect(40, 180, 55, 30);
                  //g2.fillRect(125, 180, 55, 30);
                  g2.drawLine(210, 180, 210, 210);
                  g2.drawLine(241, 180, 241, 210);
                  g2.drawLine(250, 180, 305, 180);
                  g2.drawLine(250, 210, 305, 210);
                  strokeManager.setLineStroke(g2, LineStroke.DOTTED, 3);
                  g2.drawLine(10, 220, 790, 240);
                  g2.drawRect(40, 250, 55, 30);
                  //g2.fillRect(125, 250, 55, 30);
                  g2.drawLine(210, 250, 210, 280);
                  g2.drawLine(241, 250, 241, 280);
                  g2.drawLine(250, 250, 305, 250);
                  g2.drawLine(250, 280, 305, 280);
                  strokeManager.setLineStroke(g2, LineStroke.DOTTED_SMALL, 3);
                  g2.drawLine(10, 290, 790, 310);
                  g2.drawRect(40, 320, 55, 30);
                  //g2.fillRect(125, 320, 55, 30);
                  g2.drawLine(210, 320, 210, 350);
                  g2.drawLine(241, 320, 241, 350);
                  g2.drawLine(250, 320, 305, 320);
                  g2.drawLine(250, 350, 305, 350);
                  strokeManager.setLineStroke(g2, LineStroke.DOTTED_SMALL_THIN, 3);
                  g2.drawLine(10, 360, 790, 380);
                  g2.drawRect(40, 390, 55, 30);
                  //g2.fillRect(125, 390, 55, 30);
                  g2.drawLine(210, 390, 210, 420);
                  g2.drawLine(241, 390, 241, 420);
                  g2.drawLine(250, 390, 305, 390);
                  g2.drawLine(250, 420, 305, 420);
               }
            });
            
            frame.setVisible(true);
         }
      });
   }
}

